<script setup lang="ts">
import 'leaflet/dist/leaflet.css'
import L from 'leaflet'

const props = defineProps({
    lat: {type: String, required: true},
    long: {type: String, required: true},
})

import {defineProps, onMounted, ref, onBeforeUnmount} from 'vue'

const map = ref<any>(null)

onMounted(() => {
    map.value = L.map('mapContainer').setView([41.49484630651534, 20.79235321642247], 5)
    L.tileLayer('http://{s}.tile.osm.org/{z}/{x}/{y}.png', {
        attribution: '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors',
    }).addTo(map.value)
    let customPane = map.value.createPane('customPane')
    let canvasRenderer = L.canvas({pane: 'customPane'})
    customPane.style.zIndex = 399

    if (props.lat !== 'NA' && props.long !== 'NA') {
        L.circleMarker([parseFloat(props.lat), parseFloat(props.long)], {
            radius: 5,
            opacity: 1,
            color: 'blue',
            fill: true,
            fillColor: 'blue',
            fillOpacity: 1,
        }).addTo(map.value)
    }
})

onBeforeUnmount(() => {
    if (map.value) {
        map.value.remove()
    }
})
</script>

<template>
    <div id="mapContainer"></div>
</template>

<style>
#mapContainer {
    width: 90%;
    height: 400px;
    margin: 40px auto 20px;
}
</style>
